<?php
require_once("app.php");
if(!dl('php_gtk.' . (strstr(PHP_OS, 'WIN') ? 'dll' : 'so')))
die("Please install php-gtk first!");
class app_gui extends app
{
var $widget=array();
var $type_name=array();
var $group_name=array();
var $group_widget_info=array();
var $window_name=array();
var $widget_name=array();
var $widget_global_info;
var $dialog;
var $style;

function widget_global_info_init()
  {
  $this->widget_global_info=$this->xml_2_array(DIR_PREFIX."gtk.xml");
  $this->style_init();
  $this->type_name=array_keys($this->widget_global_info);
  $this->debug_info(__LINE__.'the global info init end.');
  }

function style_init()
  	{
	$this->style=$this->xml_2_array(DIR_PREFIX.'style.xml');
	if(is_array($this->style))
		{
			$keys=array_keys($this->style);

			foreach($keys as $key)
			{
				if(is_object($this->widget[$key]['obj']))
				{
				$style=$this->widget[$key]['obj']->style;
				$this->style[$key]['obj']=$style->copy();
				if($this->style[$key]['font'])
				{
				$this->style[$key]['obj']->font=gdk::fontset_load($this->style[$key]['font']);
				}
				if($this->style[$key]['bg'])
				{
				$c=&new gdkcolor($this->style[$key]['bg']);
				$this->style[$key]['obj']->base[0]=$c;
				}
				if($this->style[$key]['text'])
				{
				$c=&new gdkcolor($this->style[$key]['text']);
				$this->style[$key]['obj']->text[0]=$c;	
				}
				if($this->style[$key]['bg_pixmap'])
				{
				$p=gdk::pixmap_create_from_xpm(null,null,$this->style[$key]['bg_pixmap']);
				$this->style[$key]['obj']->bg_pixmap[0]=$p[0];
				$this->style[$key]['obj']->bg_pixmap[1]=$p[0];
				$this->style[$key]['obj']->bg_pixmap[2]=$p[0];
				$this->style[$key]['obj']->bg_pixmap[4]=$p[0];
				}
				if($this->style[$key]['border'])
				{
				$this->widget[$key]['obj']->set_border_width($this->style[$key]['border']);	
				}
				$this->widget[$key]['obj']->set_style($this->style[$key]['obj']);
				}
				
			}
		}
	}

function widget_info_add($type,$group,$name,$info='')
  {
  if(in_array($type,$this->type_name))
  {
  $this->widget[$name]['type']=$type;
  if(!in_array($name,$this->widget_name))
  {
  $this->widget[$name]=array_merge($this->widget[$name],$this->widget_global_info[$type]);
  if(is_array($info))
  $this->widget[$name]=array_merge($this->widget[$name],$info);
  $this->debug_info('widget '.$name.' basic info load end.');
  if(!is_array($this->group_widget_info[$group]))
  $this->group_widget_info[$group]=array();
  $command=@array_push($this->group_widget_info[$group],$name);
  $e_msg='save group and widget info fail.';
  $s_msg='save group and widget info success.';
  $this->debug_1_command($command,$e_msg,$s_msg,1);
  }
  else
  $this->debug_info('the name '.$name.' has added.');
  }
  else
  $this->debug_info('the '.$type.' is not supported now.');
  }
  
function widget_set($name)
  {
  $type=$this->widget[$name]['type'];
  if($type=='window')
  {
  $this->widget_set_window($name);
  }
  if($type=='menu')
  {
  $this->widget_set_menu($name);
  }
  elseif($type=='button')
  {
  $this->widget_set_button($name);
  }
  elseif($type=='entry')
  {
  $this->widget_set_entry($name);
  }
  elseif($type=='label')
  {
  $this->widget_set_label($name);
  }
  elseif($type=='hline')
  {
  $this->widget_set_hline($name);
  }
  elseif($type=='vline')
  {
  $this->widget_set_vline($name);
  }
  elseif($type=='radio')
  {
  $this->widget_set_radio($name);
  }
  elseif($type=='progressbar')
  {
  $this->widget_set_progressbar($name);
  }
  elseif($type=='notebook')
  {
  $this->widget_set_notebook($name);
  }
  elseif($type=='notepage')
  {
  $this->widget_set_notepage($name);
  }
  elseif($type=='spinbutton')
  {
  $this->widget_set_spinbutton($name);
  }
  elseif($type=='combo')
  {
  $this->widget_set_combo($name);
  }
  elseif($type=='frame')
  {
  $this->widget_set_frame($name);
  }
  elseif($type=='checkbutton')
  {
  $this->widget_set_checkbutton($name);
  }
  elseif($type=='text')
  {
  $this->widget_set_text($name);
  }
  }

function widget_set_window($name)
  {
  $this->widget[$name]['obj']=&new gtkwindow($this->widget[$name]['windowtype']);
  $this->widget[$name]['obj']->set_title($this->widget[$name]['title']);
  $this->widget[$name]['obj']->set_modal($this->widget[$name]['modal']);
    $this->widget[$name]['fix']=&new gtkfixed();
    $this->widget[$name]['obj']->add($this->widget[$name]['fix']);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  if($this->widget[$name]['window_ltype']==0)
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  else
  $this->widget[$name]['obj']->set_position(GTK_WIN_POS_CENTER);
  if($this->widget[$name]['menu']>0)
  {
  $this->widget[$name]['menubar']=&new gtkmenubar();
  $this->widget[$name]['acgroup']=&new gtkaccelgroup();
  $this->widget[$name]['obj']->add_accel_group($this->widget[$name]['acgroup']);
  $this->widget[$name]['fix']->add($this->widget[$name]['menubar']);
  $this->widget[$name]['menubar']->set_usize($this->widget[$name]['width'],-1);
  }
  $this->widget[$name]['obj']->show_all();
  array_push($this->window_name,$name);
  }
function widget_window_update($name)
  {
  $win=$this->widget[$name]['obj']->window;
  $this->widget[$name]['x']=$win->x;
  $this->widget[$name]['y']=$win->y;
  $this->widget[$name]['width']=$win->width;
  $this->widget[$name]['height']=$win->height;
  }
function widget_set_menu($name)
  {
  switch($this->widget[$name]['ackey'])
  {
  case 'a':
  $ackey=GDK_KEY__a;
  break;
  case 'b':
  $ackey=GDK_KEY__b;
  break;
  case 'c':
  $ackey=GDK_KEY__c;
  break;
  case 'd':
  $ackey=GDK_KEY__d;
  break;
  case 'e':
  $ackey=GDK_KEY__e;
  break;
  case 'f':
  $ackey=GDK_KEY__f;
  break;
  case 'g':
  $ackey=GDK_KEY__g;
  break;
  case 'h':
  $ackey=GDK_KEY__h;
  break;
  case 'i':
  $ackey=GDK_KEY__i;
  break;
  case 'j':
  $ackey=GDK_KEY__j;
  break;
  case 'k':
  $ackey=GDK_KEY__k;
  break;
  case 'l':
  $ackey=GDK_KEY__l;
  break;
  case 'm':
  $ackey=GDK_KEY__m;
  break;
  case 'n':
  $ackey=GDK_KEY__n;
  break;
  case 'o':
  $ackey=GDK_KEY__o;
  break;
  case 'p':
  $ackey=GDK_KEY__p;
  break;
  case 'q':
  $ackey=GDK_KEY__q;
  break;
  case 'r':
  $ackey=GDK_KEY__r;
  break;
  case 's':
  $ackey=GDK_KEY__s;
  break;
  case 't':
  $ackey=GDK_KEY__t;
  break;
  case 'u':
  $ackey=GDK_KEY__u;
  break;
  case 'v':
  $ackey=GDK_KEY__v;
  break;
  case 'w':
  $ackey=GDK_KEY__w;
  break;
  case 'x':
  $ackey=GDK_KEY__x;
  break;
  case 'y':
  $ackey=GDK_KEY__y;
  break;
  case 'z':
  $ackey=GDK_KEY__z;
  break;
  default:
  $ackey='';
  break;
  }
  switch($this->widget[$name]['mod'])
  {
  case 'alt':
  $mod=GDK_MOD1_MASK;
  break;
  case 'ctrl':
  $mod=GDK_CONTROL_MASK;
  break;
  case 'shift':
  $mod=GDK_SHIFT_MASK;
  break;
  default:
  break;
  }
  switch($this->widget[$name]['flag'])
  {
  case 'v':
  $flag=GTK_ACCEL_VISIBLE;
  break;
  default:
  break;
  }
  if($this->widget[$name]['label'])
  {
  $this->widget[$name]['obj']=&new gtkmenuitem($this->widget[$name]['label']);
  if($ackey!='')
  $this->widget[$name]['obj']->add_accelerator('activate',$this->widget[$this->widget[$name]['window']]['acgroup'],$ackey,$mod,$flag);
  }
  else
  $this->widget[$name]['obj']=&new gtkmenuitem();
  if($this->widget[$name]['inh']>0)
  {
  $this->widget[$name]['menu']=&new gtkmenu();
  $this->widget[$name]['obj']->set_submenu($this->widget[$name]['menu']);
  }
  if($this->widget[$name]['father']=="top")
  {
  $this->widget[$this->widget[$name]['window']]['menubar']->append($this->widget[$name]['obj']);
  }
  else
  {
  $this->widget[$this->widget[$name]['father']]['menu']->append($this->widget[$name]['obj']);
  }
  $this->widget[$name]['obj']->show();
  }
  
function widget_set_button($name)
  {
  $this->widget[$name]['obj']=&new gtkbutton($this->widget[$name]['label']);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['obj']);
  $this->widget[$name]['obj']->show();
  }
  
function widget_set_label($name)
  {
  $this->widget[$name]['label']=&new gtklabel($this->widget[$name]['value']);
  $this->widget[$name]['obj']=&new gtkeventbox();
  $this->widget[$name]['obj']->add($this->widget[$name]['label']);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  //print_r($this->widget[$name]);
    $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['obj']);

  $this->widget[$name]['obj']->show();
  $this->widget[$name]['label']->show();
  }
  
function widget_set_entry($name)
  {
  $this->widget[$name]['obj']=&new gtkentry();
  $this->widget[$name]['obj']->set_text($this->widget[$name]['value']);
  $this->widget[$name]['obj']->set_visibility($this->widget[$name]['visibility']);
  $this->widget[$name]['obj']->set_max_length($this->widget[$name]['maxlength']);
//  print_r($this->widget[$name]);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['obj']);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$name]['obj']->show();
  }

function widget_set_hline($name)
  {
  $this->widget[$name]['obj']=&new gtkhseparator();
  $this->widget[$name]['obj']->set_sensitive(false);
  if($this->widget[$this->widget[$name]['father']]['type']=='menu')
  {
  $this->widget[$name]['menu']=&new gtkmenuitem();
  $this->widget[$name]['menu']->add($this->widget[$name]['obj']);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['menu']);
  $this->widget[$name]['menu']->show();
  $this->widget[$name]['obj']->show();
  }
  }
function widget_set_vline($name)
  {
  $this->widget[$name]['obj']=&new gtkvseparator();
  if($this->widget[$this->widget[$name]['father']]['type']=='menu')
  {
  $this->widget[$name]['menu']=&new gtkmenuitem();
  $this->widget[$name]['menu']->add($this->widget[$name]['obj']);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['menu']);
  $this->widget[$name]['menu']->show();
  $this->widget[$name]['obj']->show();
  }
  }
  
function widget_set_radio($name)
  {
  if(!$this->widget[$name]['group'])
  {
  $this->widget[$name]['obj']=&new gtkradiobutton(null,$this->widget[$name]['label']);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['obj']);
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  }
  else
  {
  $this->widget[$name]['obj']=&new gtkradiobutton($this->widget[$this->widget[$name]['group']]['obj'],$this->widget[$name]['value']);
  }
  $this->widget[$name]['obj']->show();
  }
  
function widget_set_progressbar($name)
  {
  $this->widget[$name]['adj']=&new gtkadjustment(0.5,0.0,100.0,0.0,0.0,0.0);
  $this->widget[$name]['obj']=&new gtkprogressbar($this->widget[$name]['adj']);
  if($this->widget[$name]['mode']=='percentage')
  {
  if($this->widget[$name]['usetext']==1)
  $this->widget[$name]['obj']->set_show_text(true);
  $this->widget[$name]['obj']->set_format_string($this->widget[$name]['text']);
  }
  elseif($this->widget[$name]['mode']=='activity')
  {
  $this->widget[$name]['obj']->set_activity_mode(true);
  }
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['obj']);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$name]['obj']->show();
  }
function widget_pb_update($name)
  {
  if($this->widget[$name]['mode']=='percentage')
  {
  if($this->widget[$name]['value']<=1)
  $this->widget[$name]['obj']->set_percentage($this->widget[$name]['value']);
  else
  call_user_func(array(&$this,$this->widget[$name]['finish']),'new');
  }
  elseif($this->widget[$name]['mode']=='activity')
  {
  $this->widget[$name]['obj']->set_value($this->widget[$name]['value']);
  }
  }
  
function widget_set_notebook($name)
  {
  $this->widget[$name]['obj']=&new gtknotebook();
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['obj']);
  $this->widget[$name]['obj']->set_tab_pos(GTK_POS_TOP);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$name]['obj']->realize();
  }
  
function widget_set_notepage($name)
  {
  $this->widget[$name]['label']=&new gtklabel($this->widget[$name]['title']);
  $this->widget[$name]['fix']=&new gtkfixed();
  $this->widget[$this->widget[$name]['father']]['obj']->append_page($this->widget[$name]['fix'],$this->widget[$name]['label']);
  $this->widget[$this->widget[$name]['father']]['obj']->show_all();
  }
  
function widget_set_spinbutton($name)
  {
  if(!$this->widget[$name]['value'])
  $this->widget[$name]['value']=0;
  $this->widget[$name]['adj']=&new gtkadjustment($this->widget[$name]['value'],$this->widget[$name]['min'],$this->widget[$name]['max'],$this->widget[$name]['step'],0.0,0.0);
  $this->widget[$name]['obj']=&new gtkspinbutton($this->widget[$name]['adj']);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['obj']);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$name]['obj']->show();
  }
  
function widget_set_combo($name)
  {
  $this->widget[$name]['cmb']=&new gtkcombo();
  $this->widget[$name]['obj']=$this->widget[$name]['cmb']->entry;
  if(!is_array($this->widget[$name]['list']))
  $this->widget[$name]['list']=explode(",",$this->widget[$name]['option']);
  if($this->widget[$name]['value'])
  {
  if(!in_array($this->widget[$name]['value'],$this->widget[$name]['list']))
  array_unshift($this->widget[$name]['list'],$this->widget[$name]['value']);
  $this->widget[$name]['cmb']->set_popdown_strings($this->widget[$name]['list']);
  }
  else
  $this->widget[$name]['cmb']->set_popdown_strings($this->widget[$name]['list']);
  $this->widget[$name]['obj']->set_text($this->widget[$name]['value']);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['cmb']);
  $this->widget[$name]['cmb']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['cmb']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$name]['cmb']->show();
  }
  
function widget_set_frame($name)
  {
  $this->widget[$name]['frame']=&new gtkframe($this->widget[$name]['label']);
  $this->widget[$name]['obj']=&new gtkeventbox();
  $this->widget[$name]['obj']->add($this->widget[$name]['frame']);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['obj']);
  $this->widget[$name]['obj']->show();
  $this->widget[$name]['frame']->show();
  }
  
function widget_set_checkbutton($name)
  {
  $this->widget[$name]['obj']=&new gtkcheckbutton($this->widget[$name]['label']);
  $this->widget[$name]['obj']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['obj']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['obj']);
  $this->widget[$name]['obj']->set_active($this->widget[$name]['active']);
  $this->widget[$name]['obj']->show();
  }
  
function widget_set_text($name)
  {
  $this->widget[$name]['obj']=&new gtktext($this->widget[$name]['hadj'],$this->widget[$name]['vadj']);
  $this->widget[$name]['swin']=&new gtkscrolledwindow();
  $this->widget[$name]['swin']->set_policy(1,1);
  $this->widget[$name]['swin']->set_usize($this->widget[$name]['width'],$this->widget[$name]['height']);
  $this->widget[$name]['swin']->set_uposition($this->widget[$name]['x'],$this->widget[$name]['y']);
  $this->widget[$name]['swin']->add($this->widget[$name]['obj']);
  $this->widget[$this->widget[$name]['father']][$this->widget[$name]['fathertype']]->add($this->widget[$name]['swin']);
  $this->widget[$name]['obj']->set_editable(1);
  $this->widget[$name]['obj']->set_line_wrap(1);
  $this->widget[$name]['obj']->insert_text($this->widget[$name]['value'],0);
  $this->widget[$name]['swin']->show();
  $this->widget[$name]['obj']->show();
  }
  
function widget_value_update($wname){
switch($this->widget[$wname]['type']){
case "entry":
$this->widget[$wname]['value']=$this->widget[$wname]['obj']->get_text();
break;
case "combo":
$this->widget[$wname]['value']=$this->widget[$wname]['obj']->get_text();
break;
case "text":
$this->widget[$wname]['value']=$this->widget[$wname]['obj']->get_chars(0,-1);
break;
case "combo":
default:
break;
}
}
  
function widget_connect($name)
  {
  $actions=array_keys($this->widget[$name]);
  foreach($actions as $action_str){
  if(substr($action_str,0,1)=='_')
  {
  $action_info=explode(':',$this->widget[$name][$action_str]);
  $action=substr($action_str,1);
  $this->debug_info('the '.$name.'\'s signal '.$action.' has connected');
  $this->widget[$name]['obj']->connect($action,array(&$this,$action_info[0]),$action_info[1]);
  }
  }
  }
function widget_update($name){
  $this->widget_set($name);
  $this->widget_connect($name);
}
//create widgets from a xml file
function group_load_from_xml($group_name)
  {
  $xml_name=$group_name;
  $command=@is_file($xml_name);
  $f_msg='read group '.$group_name.' xml file fail.';
  $s_msg='read group '.$group_name.' xml file success.';
  $this->debug_1_command($command,$f_msg,$s_msg,1);
  $command=@array_push($this->group_name,$group_name);
  $suc_msg='group '.$group_name.' name info update success.';
  $this->debug_1_command($command,$error_msg,$suc_msg,0);
  $widgets=$this->xml_2_array($xml_name);
  $widgets_key=array_keys($widgets);
  foreach($widgets_key as $key)
  {
  $this->widget_info_add($widgets[$key]['type'],$group_name,$key,$widgets[$key]);
  $this->widget_set($key);
  $this->widget_connect($key);
  }
  }
function group_load_from_string($string)
  {
  $widgets=unserialize(base64_decode($string));
  $widgets_key=array_keys($widgets);
  foreach($widgets_key as $key)
  {
  $this->widget_info_add($widgets[$key]['type'],$group_name,$key,$widgets[$key]);
  $this->widget_set($key);
  $this->widget_connect($key);
  }
  }  
function group_hard_destroy($group_name)
  {
  foreach($this->window_name as $w_name)
  {
  if(in_array($w_name,$this->group_widget_info[$group_name]))
  {
  $this->widget[$w_name]['obj']->destroy();
  }
  }
  $this->group_name=$this->array_delete_key($this->group_name,$group_name);
  $this->group_widget_info=$this->array_delete_key($this->group_widget_info,$group_name);
  }

function group_reload_from_xml($group_name)
  {
	  $this->group_hard_destroy($group_name);
	  $this->group_load_from_xml($group_name);
  }

function group_load_from_array($group_name)
  {
  foreach($this->group_widget_info[$group_name] as $key)
  {
  $this->widget_set($key);
  $this->widget_connect($key);
  }
  }

function group_soft_destroy($group_name)
  {
  foreach($this->window_name as $w_name)
  {
  if(in_array($w_name,$this->group_widget_info[$group_name]))
  {
  $this->widget[$w_name]['obj']->destroy();
  }
  }
  }
  
function group_reload($widget,$group_name)
  {
	  $this->group_soft_destroy($group_name);
	  $this->group_load_from_array($group_name);
  }

function widget_child_reload($widget,$w_name)
  {
  if(is_object($this->widget[$w_name]['obj']))
  $this->widget[$w_name]['obj']->destroy();
  elseif($this->widget[$w_name]['cmb'])
  $this->widget[$w_name]['cmb']->destroy();
  $this->widget_set($w_name);
  $this->widget_connect($w_name);
  }
function dlg_info($info,$ok='Ok')
  {
  $dlg=&new gtkdialog();
  $dlg->set_modal(1);
  $dlg->set_position(GTK_WINDOW_TOPLEVEL);
  $l=$dlg->vbox;
  $a=$dlg->action_area;
  $lbl=&new gtklabel(' '.$info.' ');
  $btn=&new gtkbutton($ok);
  $btn->connect_object('clicked',array(&$dlg,'destroy'));
  $l->pack_start($lbl);
  $a->pack_start($btn);
  $dlg->set_usize(280,100);
  $dlg->show_all();
  }
  
function dlg_file($title,$fun)
  {
  $dlg_id=$this->dlg_get_num();
  $this->dialog[$dlg_id]['obj']=&new gtkfileselection($title);
  $this->dialog[$dlg_id]['type']='file';
  $this->dialog[$dlg_id]['fun']=$fun;
  $this->dialog[$dlg_id]['cancel_fun']="";
  $this->dialog[$dlg_id]['ok']=$this->dialog[$dlg_id]['obj']->ok_button;
  $this->dialog[$dlg_id]['cancel']=$this->dialog[$dlg_id]['obj']->cancel_button;
  $this->dialog[$dlg_id]['ok']->connect('clicked',array(&$this,'dlg_ok'),$dlg_id);
  $this->dialog[$dlg_id]['cancel']->connect('clicked',array(&$this,'dlg_cancel'),$dlg_id);
  $this->dialog[$dlg_id]['obj']->show_all();
  return $dlg_id;
  }
function dlg_input($title,$msg,$fun,$infos)
{
	$dlg_id=$this->dlg_get_num();
	$this->dialog[$dlg_id]['obj']=&new gtkdialog();
	$this->dialog[$dlg_id]['obj']->set_modal(1);
	$this->dialog[$dlg_id]['obj']->set_title($title);
	$this->dialog[$dlg_id]['obj']->set_position(GTK_WIN_POS_CENTER);
	$this->dialog[$dlg_id]['type']='input';
	$this->dialog[$dlg_id]['fun']=$fun;
	$this->dialog[$dlg_id]['vbox']=$this->dialog[$dlg_id]['obj']->vbox;
	$this->dialog[$dlg_id]['action']=$this->dialog[$dlg_id]['obj']->action_area;
	$lbl=&new gtklabel($msg);
	$n=count($infos);
	$this->dialog[$dlg_id]['table']=&new gtktable($n+1,2);
	$this->dialog[$dlg_id]['table']->attach($lbl,0,2,0,1,0,0,5,5);
	$this->dialog[$dlg_id]['vbox']->add($this->dialog[$dlg_id]['table']);
	for($i=0;$i<$n;$i++)
	{
	$info=$infos[$i];
	$if=explode('_',$info);
	$this->dialog[$dlg_id]['name'][$i]=$if[0];
	$this->dialog[$dlg_id]['label'][$if[0]]=&new gtklabel($if[0]);
	$this->dialog[$dlg_id]['entry'][$if[0]]=&new gtkentry();
	if($if[2]=='*')
	$this->dialog[$dlg_id]['entry'][$if[0]]->set_visibility(0);
	if($if[1])
	$this->dialog[$dlg_id]['entry'][$if[0]]->set_max_length($if[1]);
	$this->dialog[$dlg_id]['table']->attach($this->dialog[$dlg_id]['label'][$if[0]],0,1,$i+1,$i+2,0,0,5,5);
	$this->dialog[$dlg_id]['table']->attach($this->dialog[$dlg_id]['entry'][$if[0]],1,2,$i+1,$i+2,0,0,5,5);
	}
	$this->dialog[$dlg_id]['ok']=&new gtkbutton('OK');
	$this->dialog[$dlg_id]['cancel']=&new gtkbutton('Cancel');
	$this->dialog[$dlg_id]['action']->add($this->dialog[$dlg_id]['ok']);
	$this->dialog[$dlg_id]['action']->add($this->dialog[$dlg_id]['cancel']);
	$this->dialog[$dlg_id]['ok']->connect('clicked',array(&$this,'dlg_ok'),$dlg_id);
	$this->dialog[$dlg_id]['obj']->connect('destroy',array(&$this,'dlg_cancel'),$dlg_id);
	$this->dialog[$dlg_id]['obj']->show_all();
	return $dlg_id;
}
function dlg_judge($title,$msg,$fun,$infos)
{
	$dlg_id=$this->dlg_get_num();
	$this->dialog[$dlg_id]['obj']=&new gtkdialog();
	$this->dialog[$dlg_id]['obj']->set_modal(1);
	$this->dialog[$dlg_id]['obj']->set_title($title);
	$this->dialog[$dlg_id]['obj']->set_position(GTK_WIN_POS_CENTER);
	$this->dialog[$dlg_id]['type']='judge';
	$this->dialog[$dlg_id]['fun']=$fun;
	$vbox=$this->dialog[$dlg_id]['obj']->vbox;
	$action=$this->dialog[$dlg_id]['obj']->action_area;
	$lbl=&new gtklabel($msg);
	$vbox->add($lbl);
	foreach($infos as $name=>$value)
	{
		$this->dialog[$dlg_id]['button'][$value]=&new gtkbutton($name);
		$this->dialog[$dlg_id]['button'][$value]->connect('clicked',array(&$this,'dlg_ok'),$dlg_id,$value);
		$action->add($this->dialog[$dlg_id]['button'][$value]);
	}
	$this->dialog[$dlg_id]['obj']->set_usize(280,100);
	$this->dialog[$dlg_id]['obj']->show_all();
	return $dlg_id;
}
function dlg_get_num()
{
	return 'dlg'.count($this->dialog);
}
function dlg_ok($widget,$dlg_id,$arg='')
  {
  switch($this->dialog[$dlg_id]['type'])
  {
  case 'file':
  $this->dialog[$dlg_id]['return']=$this->dialog[$dlg_id]['obj']->get_filename();
  //print_r($this->dialog[$dlg_id]['return']);
  break;
  case 'input':
  $this->dialog[$dlg_id]['return']=array();
  foreach($this->dialog[$dlg_id]['name'] as $name)
  {
  $value=$this->dialog[$dlg_id]['entry'][$name]->get_text();
  $this->dialog[$dlg_id]['return']=array_merge($this->dialog[$dlg_id]['return'],array($name=>$value));
  }
  $this->dialog[$dlg_id]['return']=serialize($this->dialog[$dlg_id]['return']);
  break;
  case 'judge':
  $this->dialog[$dlg_id]['return']=$arg;
  break;
  default:
  break;
  }
  call_user_func(array(&$this,$this->dialog[$dlg_id]['fun']),$this->dialog[$dlg_id]['return']);
  $this->dialog[$dlg_id]['obj']->destroy();
  }
function dlg_cancel($widget,$dlg_id,$arg='')
  {
   	if(!empty($this->dialog[$dlg_id]['cancelfun']) and is_object($this->dialog[$dlg_id]['obj']))
   	 call_user_func(array(&$this,$this->dialog[$dlg_id]['cancelfun']));
  	$this->dialog[$dlg_id]['obj']->destroy();
  }
function system_quit($a)
  {
  gtk::main_quit();
  }
}

?>
